Index: s390-tools-sles11/dasdview/dasdview.c
===================================================================
--- s390-tools-sles11.orig/dasdview/dasdview.c
+++ s390-tools-sles11/dasdview/dasdview.c
@@ -64,8 +64,8 @@ zt_error_print (const char* fmt, ...)
 static void
 print_version (void)
 {
-	printf ("%s version %s.\n", tool_name, RELEASE_STRING);
-	printf ("%s.\n", copyright_notice);
+	printf ("%s version %s\n", tool_name, RELEASE_STRING);
+	printf ("%s\n", copyright_notice);
 }
 
 static void
@@ -73,10 +73,10 @@ dasdview_usage(void)
 {
 	printf("\nprints DASD information:\n\n");
 	printf("dasdview [-b begin] [-s size] [-1|-2] \n"
-	       "         [-i] [-x] [-j]\n"
+	       "         [-i] [-x] [-j] [-c]\n"
 	       "         [-l] [-t {info|f1|f4|f5|f7|f8|f9|all}] \n"
 	       "         [-h] [-v] \n"
-	       "         {-n devno|-f node}\n"
+	       "         {-n devno|-f node} device\n"
 	       "\nwhere:\n"
 	       "-b: prints a DASD dump from 'begin'\n"
 	       "-s: prints a DASD dump with size 'size'\n"
@@ -202,7 +202,7 @@ dasdview_get_info(dasdview_info_t *info)
 	}
 
 	if (ioctl(fd, BLKGETSIZE64, &device_size) != 0) {
-	        close(fd);
+		close(fd);
 		zt_error_print("dasdview: ioctl error\n" \
 			"Could not retrieve device size information.\n");
 		exit(-1);
@@ -362,7 +362,7 @@ dasdview_dump_array(char *name, int size
 static void
 dasdview_print_extended_info(dasdview_info_t *info)
 {
-	int i;
+	unsigned int i;
 	struct dasd_information2_t *dasd_info;
 	struct {
 		unsigned int mask;
@@ -634,15 +634,15 @@ dasdview_read_vtoc(dasdview_info_t *info
 
 	vtocblk = (u_int64_t) vtoc_get_cyl_from_cchhb(&vlabel.vtoc) *
 		info->geo.heads * info->geo.sectors +
-                vtoc_get_head_from_cchhb(&vlabel.vtoc) * info->geo.sectors +
-                vlabel.vtoc.b;
+		vtoc_get_head_from_cchhb(&vlabel.vtoc) * info->geo.sectors +
+		vlabel.vtoc.b;
 
 	/*
 	 * geo.cylinders is the minimum of hw_cylinders and LV_COMPAT_CYL
 	 * Actually the vtoc should be located in in the first 65k-1 tracks
-         * so this check could be even more restrictive, but it doesn't
-         * hurt the way it is. Linux cdl format restricts the vtoc to
-         * the first two tracks anyway.
+	 * so this check could be even more restrictive, but it doesn't
+	 * hurt the way it is. Linux cdl format restricts the vtoc to
+	 * the first two tracks anyway.
 	 */
 	maxblk = info->geo.cylinders * info->geo.heads * info->geo.sectors;
 
@@ -982,7 +982,7 @@ static void dasdview_print_format1_8_ful
 
 static void dasdview_print_vtoc_f1(dasdview_info_t *info)
 {
-        int j;
+	int j;
 
 	printf("--- VTOC format 1 labels ----------------------" \
 	       "---------------------------------\n");
@@ -1001,14 +1001,14 @@ static void dasdview_print_vtoc_f1(dasdv
 
 static void dasdview_print_vtoc_f8(dasdview_info_t *info)
 {
-        int j;
+	int j;
 
 	printf("--- VTOC format 8 labels ----------------------" \
 	       "---------------------------------\n");
 
 	if (info->f8c < 1)
 	{
-	        printf("This VTOC doesn't contain a format 8 label.\n");
+		printf("This VTOC doesn't contain a format 8 label.\n");
 		return;
 	}
 
@@ -1229,13 +1229,13 @@ dasdview_print_vtoc_f7(dasdview_info_t *
 static void
 dasdview_print_vtoc_f9(dasdview_info_t *info)
 {
-        int i,j;
+	unsigned int i;
+	int j;
 
 	printf("\n--- VTOC format 9 label ----------------------" \
 	       "---------------------------------\n");
 
-	if (info->f9c < 1)
-	{
+	if (info->f9c < 1) {
 	        printf("This VTOC doesn't contain a format 9 label.\n");
 		return;
 	}
@@ -1251,10 +1251,10 @@ dasdview_print_vtoc_f9(dasdview_info_t *
 
 		printf("res1        : hex ");
 		for (i=0; i < sizeof(info->f9[j].res1); i++) {
-			if ( (i > 0) && (i % 16 == 0) )
+			if ((i > 0) && (i % 16 == 0))
 				printf("\n                  ");
 			printf("%02x", info->f9[j].res1[i]);
-			if ( (i+9) % 16 == 0 )
+			if ((i+9) % 16 == 0)
 				printf(" ");
 		}
 		printf("\n");
@@ -1264,10 +1264,10 @@ dasdview_print_vtoc_f9(dasdview_info_t *
 
 		printf("res2        : hex ");
 		for (i=0; i < sizeof(info->f9[j].res2); i++) {
-			if ( (i > 0) && (i % 16 == 0) )
+			if ((i > 0) && (i % 16 == 0))
 				printf("\n                  ");
 			printf("%02x", info->f9[j].res2[i]);
-			if ( (i+9) % 16 == 0 )
+			if ((i+9) % 16 == 0)
 				printf(" ");
 		}
 		printf("\n");
@@ -1449,7 +1449,7 @@ dasdview_view(dasdview_info_t *info)
 	{
 		bzero(dumpstr, DUMP_STRING_SIZE);
 		rc = read(fd, &dumpstr, k);
-		if (rc != k)
+		if (rc != (int) k)
 		{
 			close(fd);
 			zt_error_print("dasdview: read error\n" \
@@ -1484,13 +1484,14 @@ dasdview_view(dasdview_info_t *info)
 static void
 dasdview_print_characteristic(dasdview_info_t *info)
 {
-		 dasd_information2_t dasd_info;
-		 dasd_info = info->dasd_info;
-		 printf("encrypted disk         : %s\n",
-			(dasd_info.characteristics[46]&0x80) ? "yes" : "no");
+	dasd_information2_t dasd_info;
+	dasd_info = info->dasd_info;
+	printf("encrypted disk         : %s\n",
+	       (dasd_info.characteristics[46]&0x80)?"yes":"no");
+	printf("solid state device     : %s\n",
+	       (dasd_info.characteristics[46]&0x40)?"yes":"no");
 }
 
-
 int main(int argc, char * argv[]) {
 
 	dasdview_info_t info;
@@ -1569,10 +1570,10 @@ int main(int argc, char * argv[]) {
 		        else if (strncmp(optarg,"f7",2)==0)
 		                info.vtoc_f7 = 1;
 		        else if (strncmp(optarg,"f8",2)==0)
-		                info.vtoc_f8 = 1;
-		        else if (strncmp(optarg,"f9",2)==0)
-		                info.vtoc_f9 = 1;
-		        else if (strncmp(optarg,"all",3)==0)
+				info.vtoc_f8 = 1;
+			else if (strncmp(optarg,"f9",2)==0)
+				info.vtoc_f9 = 1;
+			else if (strncmp(optarg,"all",3)==0)
 		                info.vtoc_all = 1;
 		        else
 		        {
@@ -1584,14 +1585,14 @@ int main(int argc, char * argv[]) {
 		        info.vtoc = 1;
 			info.action_specified = 1;
 			break;
-		case 'c':
-			info.action_specified = 1;
-			info.characteristic_specified = 1;
-			break;
 		case 'l':
 			info.action_specified = 1;
 			info.vlabel_info = 1;
 			break;
+		case 'c':
+			info.action_specified = 1;
+			info.characteristic_specified = 1;
+			break;
 		case -1:
 			/* End of options string - start of devices list */
 			info.device_id = optind;
@@ -1745,12 +1746,12 @@ int main(int argc, char * argv[]) {
 
 	if (info.vtoc_f8 || info.vtoc_all)
 	{
-	        dasdview_print_vtoc_f8(&info);
+		dasdview_print_vtoc_f8(&info);
 	}
 
 	if (info.vtoc_f9 || info.vtoc_all)
 	{
-	        dasdview_print_vtoc_f9(&info);
+		dasdview_print_vtoc_f9(&info);
 	}
 
 	if (!info.action_specified)
Index: s390-tools-sles11/dasdview/dasdview.h
===================================================================
--- s390-tools-sles11.orig/dasdview/dasdview.h
+++ s390-tools-sles11/dasdview/dasdview.h
@@ -101,7 +101,8 @@ typedef struct dasd_information2_t {
  *******************************************************************************/
 /* get block device sector size */
 #define BLKSSZGET  _IO(0x12,104)
-#define BLKGETSIZE64 _IOR(0x12,114,size_t) /* return device size in bytes (u64 *arg) */
+/* return device size in bytes (u64 *arg) */
+#define BLKGETSIZE64 _IOR(0x12,114,size_t)
 
 /* get device geometry */
 #define HDIO_GETGEO		0x0301
@@ -110,8 +111,6 @@ typedef struct dasd_information2_t {
  * SECTION: DASDVIEW internal types
  *******************************************************************************/
 
-#define DASDVIEW_VERSION "1.02"
-
 #define LINE_LENGTH 80
 #define DASDVIEW_ERROR "dasdview:"
 #define DEFAULT_BEGIN 0
Index: s390-tools-sles11/fdasd/fdasd.c
===================================================================
--- s390-tools-sles11.orig/fdasd/fdasd.c
+++ s390-tools-sles11/fdasd/fdasd.c
@@ -29,8 +29,8 @@ static const char copyright_notice[] = "
 static void
 print_version (void)
 {
-	printf ("%s version %s.\n", tool_name, RELEASE_STRING);
-	printf ("%s.\n", copyright_notice);
+	printf ("%s version %s\n", tool_name, RELEASE_STRING);
+	printf ("%s\n", copyright_notice);
 }
 
 static int
@@ -95,7 +95,7 @@ static void get_addr_of_highest_f1_f8_la
 		record++;
 	if (anc->formatted_cylinders > LV_COMPAT_CYL)
 		record += anc->used_partitions - 1;
-        vtoc_set_cchhb(addr, VTOC_START_CC, VTOC_START_HH, record);
+	vtoc_set_cchhb(addr, VTOC_START_CC, VTOC_START_HH, record);
 }
 
 /* 
@@ -288,10 +288,12 @@ static int
 yes_no(char *question_str) 
 {
 	char answer;
-	
+	int rc;
 	while (1) {
 		printf("%s (y/n): ", question_str);
-		scanf("%c", &answer);
+		rc = scanf("%c", &answer);
+		if (rc != 1)
+			return -1;
 		if (answer == 'y') return 0;
 		if (answer == 'n') return 1;
 	}
@@ -541,7 +543,8 @@ fdasd_parse_conffile(fdasd_anchor_t *anc
 {
 	char buffer[USABLE_PARTITIONS * LINE_LENGTH];
 	char err_str[ERROR_STRING_SIZE], *c1, *c2;
-	int fd, i=0;
+	int fd, rc;
+	unsigned i=0;
 
 	/* if name of config file was not specified, select the default */
 	if (options->conffile == NULL)
@@ -558,7 +561,9 @@ fdasd_parse_conffile(fdasd_anchor_t *anc
 	}
 
 	bzero(buffer, sizeof(buffer));
-	read(fd, buffer, sizeof(buffer));
+	rc = read(fd, buffer, sizeof(buffer));
+	if (rc < 0)
+		return -1;
 	close(fd);
 
 
@@ -1080,7 +1085,7 @@ fdasd_write_vtoc_labels (fdasd_anchor_t 
 	/* write FMT7 DSCB */
 	if (anc->big_disk) {
 		vtoc_write_label(options.device, blk,  NULL, NULL,
-				 NULL,anc->f7, NULL);
+				 NULL, anc->f7, NULL);
 		if (anc->verbose) printf("f7 ");
 		blk += anc->blksize;
 	}
@@ -1148,7 +1153,7 @@ fdasd_write_vtoc_labels (fdasd_anchor_t 
 		vtoc_ebcdic_enc(ch, ch, 44);
 		if (anc->verbose) printf("%2x ", part_info->f1->DS1FMTID);
 
-		if (part_info->f1->DS1FMTID == 0xf8 ) {
+		if (part_info->f1->DS1FMTID == 0xf8) {
 			/* Now as we know where which label will be written, we
 			 * can add the address of the format 9 label to the
 			 * format 8 label. The f9 record will be written to the
@@ -1156,7 +1161,8 @@ fdasd_write_vtoc_labels (fdasd_anchor_t 
 			 * by one, so we have to add 2 and not just one.
 			 */
 			vtoc_set_cchhb(&f9addr, VTOC_START_CC, VTOC_START_HH,
-				       ((blk / anc->blksize) % geo.sectors) + 2);
+				       ((blk / anc->blksize) % geo.sectors)
+				       + 2);
 			vtoc_update_format8_label(&f9addr, part_info->f1);
 			vtoc_write_label(options.device, blk, part_info->f1,
 					 NULL, NULL, NULL, NULL);
@@ -1324,12 +1330,14 @@ fdasd_reuse_vtoc(fdasd_anchor_t *anc)
 			continue;
 		}
 
-		if (anc->formatted_cylinders > LV_COMPAT_CYL) {
-		    vtoc_init_format8_label(anc->vlabel->volid, anc->blksize,
-					    &part_info->f1->DS1EXT1, &f1);
-		} else
-		    vtoc_init_format1_label(anc->vlabel->volid, anc->blksize,
-					    &part_info->f1->DS1EXT1, &f1);
+		if (anc->formatted_cylinders > LV_COMPAT_CYL)
+			vtoc_init_format8_label(anc->vlabel->volid,
+						anc->blksize,
+						&part_info->f1->DS1EXT1, &f1);
+		else
+			vtoc_init_format1_label(anc->vlabel->volid,
+						anc->blksize,
+						&part_info->f1->DS1EXT1, &f1);
 
 
 		strncpy(f1.DS1DSNAM, part_info->f1->DS1DSNAM, 44);
@@ -1390,8 +1398,7 @@ fdasd_change_volser (fdasd_anchor_t *anc
 static void
 fdasd_change_part_type (fdasd_anchor_t *anc)
 {
-        int i;
-        unsigned int part_id, part_type;
+        unsigned int part_id, part_type, i;
 	char str[20], *ch;
         partition_info_t *part_info;
 
@@ -1406,7 +1413,7 @@ fdasd_change_part_type (fdasd_anchor_t *
 	printf("\n");
         if (part_id == 0) 
 		return;
-        if ((part_id < 0) || (part_id > anc->used_partitions)) {
+        if (part_id > anc->used_partitions) {
                 printf("'%d' is not a valid partition id!\n", part_id);
                 return;
         }
@@ -1510,7 +1517,7 @@ fdasd_update_partition_info (fdasd_ancho
 	anc->used_partitions = geo.sectors - 2 - anc->f4->DS4DSREC;
 
         for (i=1; i<=USABLE_PARTITIONS; i++) {
-	        if (part_info->f1->DS1FMTID != 0xf1 &&
+		if (part_info->f1->DS1FMTID != 0xf1 &&
 		    part_info->f1->DS1FMTID != 0xf8) {
 		        if (i == 1)
 				/* there is no partition at all */
@@ -1653,7 +1660,8 @@ fdasd_process_valid_vtoc(fdasd_anchor_t 
 			if (anc->verbose)
 				printf("%s ",
 				       f1_label.DS1FMTID == 0xf1 ? "f1" : "f8");
-			if (part_info == NULL) break;
+			if (part_info == NULL)
+				break;
 			memcpy(part_info->f1, &f1_label, f1_size);
 
 			part_no = -1;
@@ -1694,7 +1702,7 @@ fdasd_process_valid_vtoc(fdasd_anchor_t 
 			break;
 		case 0xf9:
 			/* each format 8 lable has an associated format 9 lable,
-                         * but they are of no further use to us.
+			 * but they are of no further use to us.
 			 */
 			if (anc->verbose) printf("f9 ");
 			break;
@@ -1725,8 +1733,6 @@ fdasd_process_valid_vtoc(fdasd_anchor_t 
 static int
 fdasd_valid_vtoc_pointer(fdasd_anchor_t *anc, unsigned long blk)
 {
-	char str[INPUT_BUF_SIZE];
-
 	/* VOL1 label contains valid VTOC pointer */
 	if (!anc->silent)
 		printf("reading vtoc ..........:");
@@ -1739,8 +1745,7 @@ fdasd_valid_vtoc_pointer(fdasd_anchor_t 
 			return -1;
 		}
 		fdasd_process_invalid_vtoc(anc);
-	}
-	else
+	} else
 		fdasd_process_valid_vtoc(anc, blk);
 
 	return 0;
@@ -1798,9 +1803,10 @@ static int
 fdasd_check_volume (fdasd_anchor_t *anc) 
 {
 	volume_label_t *vlabel = anc->vlabel;
-        long long blk = -1;
+	long long blk = -1;
 	char str[LINE_LENGTH];
 	char inp_buf[INPUT_BUF_SIZE];
+	int rc = 1;
 
 	if (!anc->silent)
 		printf("reading volume label ..:");
@@ -1830,8 +1836,9 @@ fdasd_check_volume (fdasd_anchor_t *anc)
 	} else {
 	        /* didn't find VOL1 volume label */
 
-		if (anc->print_table) {
-			printf("\nCould not find VOL1 volume label.\n");
+		if (anc->print_table || anc->print_volser) {
+			printf("\nCannot show requested information because "
+			       "the disk label block is invalid\n");
 			return -1;
 		}
 
@@ -1844,12 +1851,12 @@ fdasd_check_volume (fdasd_anchor_t *anc)
 		else {
 			if (!anc->silent)
 				printf(" no known label\n");
-			strcpy(inp_buf,"Should I create a new one?");
+			if (!anc->auto_partition)
+				rc = yes_no("Should I create a new one?");
 		}
-                if ((!anc->print_volser) && (!anc->print_table) && 
-		    (yes_no(inp_buf) == 1)) {
-		        printf("You need a VOL1 volume label for " \
-		               "partitioning\nexiting...\n");
+                if ((!anc->print_volser) && (!anc->print_table) && (rc == 1)) {
+			printf("Disc does not contain a VOL1 label, cannot "
+			       "create partitions.\nexiting... \n");
 			fdasd_exit(anc, -1);
                 }
 
@@ -1863,7 +1870,8 @@ fdasd_check_volume (fdasd_anchor_t *anc)
 			}
 		}
 		anc->formatted_cylinders = anc->hw_cylinders;
-		anc->fspace_trk = anc->formatted_cylinders * geo.heads - FIRST_USABLE_TRK;
+		anc->fspace_trk = anc->formatted_cylinders * geo.heads
+				  - FIRST_USABLE_TRK;
 
 		fdasd_init_volume_label(anc);
 
@@ -1977,8 +1985,8 @@ fdasd_get_geometry (fdasd_anchor_t *anc)
 	}
 
 	if (ioctl(fd, BLKGETSIZE64, &device_size) != 0) {
-	        close(fd);
-	        fdasd_error(anc, unable_to_ioctl,
+		close(fd);
+		fdasd_error(anc, unable_to_ioctl,
 			    "Could not retrieve device size information.");
 	}
 
@@ -2174,7 +2182,7 @@ fdasd_get_partition_data (fdasd_anchor_t
 
 	start = FIRST_USABLE_TRK;
 
- 	cyl = get_usable_cylinders(anc);
+	cyl = get_usable_cylinders(anc);
 	head = anc->f4->DS4DEVCT.DS4DSTRK;
 	limit = (head * cyl - 1);
 
@@ -2430,8 +2438,7 @@ static void
 fdasd_remove_partition (fdasd_anchor_t *anc) 
 {
 	cchhb_t hf1;
-        int i;
-        unsigned int part_id;
+        unsigned int part_id, i;
 	unsigned long start, stop;
 	partition_info_t *part_info = anc->first;
 
@@ -2444,7 +2451,7 @@ fdasd_remove_partition (fdasd_anchor_t *
 	printf("\n");
 	part_id -= 48;
 	if (part_id == 0) return;
-        if ((part_id < 0) || (part_id > anc->used_partitions)) {
+        if (part_id > anc->used_partitions) {
                 printf("'%d' is not a valid partition id!\n", part_id);
                 return;
         }
@@ -2590,7 +2597,7 @@ fdasd_auto_partition_conffile(fdasd_anch
 		}
 	}
 	else {
-		if (options.volser == NULL) 
+		if (options.volser == NULL)
 			sprintf(volser, "0X%04x", anc->devno);
 		else {
 			bzero(volser, VOLSER_LENGTH + 1);
@@ -2598,7 +2605,6 @@ fdasd_auto_partition_conffile(fdasd_anch
 			fdasd_check_volser(volser, anc->devno);
 		}
 		vtoc_volume_label_set_volser(vlabel, volser);
-
 	}
 
 	vtoc_set_cchhb(&vlabel->vtoc, VTOC_START_CC, VTOC_START_HH, 0x01);
Index: s390-tools-sles11/ip_watcher/start_hsnc.sh
===================================================================
--- s390-tools-sles11.orig/ip_watcher/start_hsnc.sh
+++ s390-tools-sles11/ip_watcher/start_hsnc.sh
@@ -36,14 +36,13 @@ function __usage
 
 function PrintVersion
 {
-        echo "$script_name version %S390_TOOLS_VERSION%($version)."
-        echo "Copyright IBM Corp. 2003, 2006."
+        echo "$script_name version %S390_TOOLS_VERSION%"
+        echo "Copyright IBM Corp. 2003, 2006"
 }
 #
 # main
 #
 
-version="2.0"
 script_name="HiperSocket Network Concentrator"      # name of this script
 #
 # what is the kernel version we are on ?
Index: s390-tools-sles11/scripts/scsi_logging_level
===================================================================
--- s390-tools-sles11.orig/scripts/scsi_logging_level
+++ s390-tools-sles11/scripts/scsi_logging_level
@@ -47,8 +47,8 @@ eval set -- "$OPTS"
 printversion()
 {
     cat <<EOF
-$SCRIPTNAME: version %S390_TOOLS_VERSION%.
-Copyright IBM Corp. 2006.
+$SCRIPTNAME: version %S390_TOOLS_VERSION%
+Copyright IBM Corp. 2006
 EOF
 }
 
Index: s390-tools-sles11/tunedasd/src/tunedasd.c
===================================================================
--- s390-tools-sles11.orig/tunedasd/src/tunedasd.c
+++ s390-tools-sles11/tunedasd/src/tunedasd.c
@@ -190,8 +190,8 @@ print_usage (void)
 static void
 print_version (void)
 {
-	printf ("%s version %s.\n", tool_name, RELEASE_STRING);
-	printf ("%s.\n", copyright_notice);
+	printf ("%s version %s\n", tool_name, RELEASE_STRING);
+	printf ("%s\n", copyright_notice);
 }
 
 
Index: s390-tools-sles11/zconf/chzcrypt
===================================================================
--- s390-tools-sles11.orig/zconf/chzcrypt
+++ s390-tools-sles11/zconf/chzcrypt
@@ -67,7 +67,7 @@ function print_usage() {
 function print_version() {
     cat <<-EOF
 	$CMD: version %S390_TOOLS_VERSION%
-	Copyright IBM Corp. 2007.
+	Copyright IBM Corp. 2007
 	EOF
 }
 
@@ -253,5 +253,4 @@ for DEV in $DEV_LIST ; do
              "$ONLINE_TEXT."
 	exit 1
     fi
-    shift
 done
Index: s390-tools-sles11/zconf/lschp
===================================================================
--- s390-tools-sles11.orig/zconf/lschp
+++ s390-tools-sles11/zconf/lschp
@@ -48,7 +48,7 @@ EOF
 function print_version()
 {
 	cat <<EOF
-${TOOLNAME}: version ${VERSION}.
+${TOOLNAME}: version ${VERSION}
 Copyright IBM Corp. 2007
 EOF
 }
Index: s390-tools-sles11/zfcpdump/kernel/dump.c
===================================================================
--- s390-tools-sles11.orig/zfcpdump/kernel/dump.c
+++ s390-tools-sles11/zfcpdump/kernel/dump.c
@@ -24,6 +24,7 @@
 #include <asm/sigp.h>
 #include <asm/lowcore.h>
 #include <asm/debug.h>
+#include <asm/checksum.h>
 #include "dump.h"
 
 /*******************************************************************
@@ -35,6 +36,7 @@
 #define DUMP_SAVE_AREA_BASE_ESAME 4608
 #define DUMP_SAVE_AREA_BASE_ESA   212
 
+#define DUMP_LC_DUMP_REIPL      0xe00 /* ipib address and checksum */
 #define DUMP_LC_ARCH_MODE_ADDR  0xa3  /* dec. 163: Address of arch id tag */
 #define DUMP_LC_ARCH_MODE_ESAME 1     /* esame mode id tag */
 #define DUMP_LC_ARCH_MODE_ESA   0     /* esa mode id tag */
@@ -167,11 +169,30 @@ static struct {
 } dump;
 
 struct ipl_block_fcp *fcp_data;
+static struct ipl_parameter_block *ipl_block;
+
+struct ipib_info {
+	unsigned long	ipib;
+	u32		checksum;
+} __attribute__((packed));
 
 /*******************************************************************
  * functions
  *******************************************************************/
 
+int diag308(unsigned long subcode, void *addr)
+{
+	register unsigned long _addr asm("0") = (unsigned long) addr;
+	register unsigned long _rc asm("1") = 0;
+
+	asm volatile(
+		"	diag	%0,%2,0x308\n"
+		"0:\n"
+		: "+d" (_addr), "+d" (_rc)
+		: "d" (subcode) : "cc", "memory");
+	return _rc;
+}
+
 /*
  * Get the debug level
  */
@@ -575,6 +596,50 @@ void setup_dump_base(void)
 }
 
 /*
+ * Provide IPL parameter information block from either HSA or memory
+ * for future reipl
+ */
+static int __init zcore_reipl_init(void)
+{
+	struct ipib_info ipib_info;
+	int rc;
+
+	rc = sdias_memcpy((char *) &ipib_info, (void *) DUMP_LC_DUMP_REIPL,
+			  sizeof(ipib_info));
+	if (rc) {
+		DUMP_PRINT_ERR("sdias memcpy of ipib address and checksum "
+			       "failed\n");
+		return rc;
+	}
+	if (ipib_info.ipib == 0)
+		return 0;
+	ipl_block = (void *) __get_free_page(GFP_KERNEL);
+	if (!ipl_block)
+		return -ENOMEM;
+	if (ipib_info.ipib < dump.sa_mem_size)
+		rc = sdias_memcpy((char *) ipl_block, (void *) ipib_info.ipib,
+				  PAGE_SIZE);
+	else {
+		memcpy_absolute(ipl_block, (void *) ipib_info.ipib,
+				PAGE_SIZE);
+		rc = 0;
+	}
+	if (rc) {
+		DUMP_PRINT_ERR("Copy of IPL parameter information block "
+			       "failed\n");
+		free_page((unsigned long) ipl_block);
+		return rc;
+	}
+	if (csum_partial((char *) ipl_block, ipl_block->header.length, 0) !=
+	    ipib_info.checksum) {
+		DUMP_PRINT_ERR("Checksum does not match\n");
+		free_page((unsigned long) ipl_block);
+		ipl_block = NULL;
+	}
+	return 0;
+}
+
+/*
  * Initialize dump globals for a given architecture
  */
 
@@ -601,7 +666,7 @@ dump_init(void)
 	DUMP_PRINT_TRACE("DUMP init\n");
 
 	if(sdias_init()){
-		DUMP_PRINT_ERR("could initialize sclp\n");
+		DUMP_PRINT_ERR("could not initialize sclp\n");
 		rc = -1; goto out;
 	}
 	hsa_nr_of_blocks = sdias_get_nr_blocks();
@@ -630,7 +695,7 @@ dump_init(void)
 
 	DUMP_PRINT_TRACE("64 bit System dumper\n");
 	if(sdias_memcpy(&arch_id,(void*)(DUMP_LC_ARCH_MODE_ADDR),1) < 0){
-		DUMP_PRINT_ERR("sdial memcpy for arch id failed\n");
+		DUMP_PRINT_ERR("sdias memcpy for arch id failed\n");
 		dump.error_code = ZCORE_ERR_HSA_FEATURE;
 		rc = -1; goto out;
 	}
@@ -687,6 +752,12 @@ dump_init(void)
 	}
 	dump.mem_size = memory_size;
 	dump_print_glob_info();
+	if (zcore_reipl_init()) {
+		DUMP_PRINT_ERR("zcore_reipl_init failed\n");
+		dump.error_code = ZCORE_ERR_REIPL;
+		rc = -1;
+		goto out;
+	}
 	if(zcore_init() < 0){
 		DUMP_PRINT_ERR("zcore init failed\n");
 		dump.error_code = ZCORE_ERR_OTHER;
@@ -703,6 +774,7 @@ out:
 void __exit
 dump_exit(void)
 {
+	free_page((unsigned long) ipl_block);
 	zcore_exit();
 	kfree(dump.arch_info.cpu_info);
 }
@@ -977,7 +1049,6 @@ zcore_ioctl(struct inode *inode, struct 
 		case ZCORE_IOCTL_RELEASE_HSA:
 		{
 			uint32_t* psw;
-			unsigned long r1,r2;
 
 			/* set disabled wait psw in lowcore */
 			smp_ctl_clear_bit(0,28); /* disable lc protection */
@@ -995,13 +1066,7 @@ zcore_ioctl(struct inode *inode, struct 
 			       : "cc"
 			);
 #else
-			r1 = 0x0;
-			r2 = 0x2;
-			asm volatile ("   diag  %0,%1,0x308\n"
-				: 
-				: "d" (r1), "d" (r2)
-				: "cc"
-                        );
+			diag308(DIAG308_REL_HSA, NULL);
 #endif
 			break;
 		}
@@ -1013,6 +1078,12 @@ zcore_ioctl(struct inode *inode, struct 
 				rc = -EFAULT;
 			}
 			break;
+		case ZCORE_IOCTL_REIPL:
+			if (ipl_block) {
+				diag308(DIAG308_SET, ipl_block);
+				diag308(DIAG308_IPL, NULL);
+			}
+			break;
 		default:
 			DUMP_PRINT_ERR("invalid zcore ioctl: %x\n",cmd);
 			rc = -EINVAL;
Index: s390-tools-sles11/zfcpdump/kernel/dump.h
===================================================================
--- s390-tools-sles11.orig/zfcpdump/kernel/dump.h
+++ s390-tools-sles11/zfcpdump/kernel/dump.h
@@ -12,15 +12,23 @@
 #define ZCORE_IOCTL_RELEASE_HSA	0x2
 #define ZCORE_IOCTL_GET_ERROR	0x3
 #define ZCORE_IOCTL_HSASIZE	0x4
+#define ZCORE_IOCTL_REIPL	0x5
 
 #define ZCORE_ERR_OK		0x0
 #define ZCORE_ERR_HSA_FEATURE	0x1
 #define ZCORE_ERR_CPU_INFO	0x2
 #define ZCORE_ERR_OTHER		0x3
+#define ZCORE_ERR_REIPL		0x4
 
 #define BOOT_TYPE_IPL		0x10
 #define BOOT_TYPE_DUMP		0x20
 
+enum diag308_subcode  {
+	DIAG308_REL_HSA	= 2,
+	DIAG308_IPL	= 3,
+	DIAG308_SET	= 5,
+};
+
 void setup_dump_base(void);
 void setup_dump_devnos(char *cmdline, unsigned int init_devno,
 		       unsigned int console_devno);
Index: s390-tools-sles11/zfcpdump/ramdisk/zfcp_dumper.c
===================================================================
--- s390-tools-sles11.orig/zfcpdump/ramdisk/zfcp_dumper.c
+++ s390-tools-sles11/zfcpdump/ramdisk/zfcp_dumper.c
@@ -19,6 +19,7 @@
 #include <string.h>
 #include <zlib.h>
 #include <sys/stat.h>
+#include <sys/wait.h>
 #include <unistd.h>
 #include <stdio.h>
 #include <stdint.h>
@@ -410,7 +411,7 @@ static int parse_parmline(void){
 	PRINT_TRACE("dump part : %s\n",g.parm_dump_part);
 	PRINT_TRACE("dump comp : %s\n",g.parm_dump_compress);
 	PRINT_TRACE("dump debug: %d\n",g.parm_dump_debug); 
-	PRINT_TRACE("dump mem:   %llx\n",g.parm_dump_mem); 
+	PRINT_TRACE("dump mem:   %llx\n", (unsigned long long) g.parm_dump_mem);
 		
 	if(g.parm_dump_mode == PARM_DUMP_MODE_AUTO_NUM){
 		PRINT_TRACE("dump mode : %s\n",PARM_DUMP_MODE_AUTO);
@@ -552,8 +553,6 @@ out:
  */
 int enable_zfcp_device(struct ipl_block_fcp *fcp_info)
 {
-	int fh = -1, fh_check;
-	int rc = 0;
 	char command_string[1024] = {0};
 	char fcp_file[1024] = {0};
 
@@ -563,14 +562,17 @@ int enable_zfcp_device(struct ipl_block_
 	PRINT_TRACE("online: %s %s\n",command_string,fcp_file);
 	if(write_to_file(fcp_file, command_string))
 		return -1;
-	sprintf(command_string, "0x%016llx\n",fcp_info->wwpn);
+	sprintf(command_string, "0x%016llx\n",
+		(unsigned long long) fcp_info->wwpn);
 	sprintf(fcp_file,"/sys/bus/ccw/drivers/zfcp/0.0.%04x/port_add",
 		fcp_info->devno);
 	if(write_to_file(fcp_file, command_string))
 		return -1;
-	sprintf(command_string, "0x%016llx\n",fcp_info->lun);
+	sprintf(command_string, "0x%016llx\n",
+		(unsigned long long) fcp_info->lun);
 	sprintf(fcp_file,"/sys/bus/ccw/drivers/zfcp/0.0.%04x/0x%016llx/"
-		"unit_add",fcp_info->devno,fcp_info->wwpn);
+		"unit_add", fcp_info->devno,
+		(unsigned long long) fcp_info->wwpn);
 	if(write_to_file(fcp_file, command_string))
 		return -1;
 	return 0;
@@ -639,7 +641,7 @@ out:
  */
 static void release_hsa(void)
 {
-	int fh;
+	int fh = -1;
 
 	if(g.hsa_released){
 		goto out;
@@ -726,8 +728,8 @@ int main(int argc, char* argv[])
 	PRINT("DUMP PARAMETERS:\n");
 	PRINT("================\n");
 	PRINT("devno    : %x\n",fcp_info.devno);
-	PRINT("wwpn     : %016llx\n",fcp_info.wwpn);
-	PRINT("lun      : %016llx\n",fcp_info.lun);
+	PRINT("wwpn     : %016llx\n", (unsigned long long) fcp_info.wwpn);
+	PRINT("lun      : %016llx\n", (unsigned long long) fcp_info.lun);
 	PRINT("conf     : %i\n",fcp_info.bootprog);
 	PRINT("partition: %s\n",g.parm_dump_part);
 	PRINT("directory: %s\n",g.parm_dump_dir);
@@ -771,6 +773,29 @@ out:
 	}
 	fflush(stdout);
 	dump_terminate();
+	return rc;
+}
+
+
+/*
+ * trigger_reipl()
+ *
+ * Issue ioctl system call to trigger reipl. The zcore device driver
+ * issues the necessary diag308 calls only if valid ipib address and checksum
+ * were found in lowcore. Otherwise the ZCORE_IOCTL_REIPL ioctl won't do
+ * anything at all.
+ */
+void trigger_reipl(void)
+{
+	int fh;
+
+	fh = open(DEV_ZCORE, O_RDWR);
+	if (fh == -1) {
+		PRINT_PERR("open %s failed", DEV_ZCORE);
+		return;
+	}
+	ioctl(fh, ZCORE_IOCTL_REIPL, 0);
+	close(fh);
 }
 
 /*
@@ -783,6 +808,7 @@ dump_terminate(void)
 {
 	release_hsa();
 	sleep(SLEEP_TIME_END); /* give the messages time to be displayed */
+	trigger_reipl();
 	reboot(LINUX_REBOOT_CMD_POWER_OFF);
 }
 
@@ -857,7 +883,7 @@ dump_tune_vm(void)
 				"/proc/sys/vm/lowmem_reserve_ratio",
 				NULL};
 	char* sysctl_values[] = {"2","5","50","50","500","32",NULL};
-	int fh, i=0, rc=0;
+	int fh = -1, i=0, rc=0;
 
 	while(sysctl_names[i]){
 		fh = open(sysctl_names[i],O_RDWR);
@@ -1182,7 +1208,7 @@ dump_create_s390sa(char* sourcedev, char
 	char dump_file_name[1024];
 	uint64_t mem_loc;
 	uint32_t buf_loc = 0;
-	int size,fp_src, fp_dump;
+	int size, fp_src = 0, fp_dump = 0;
 	uint32_t dp_size,dp_flags;
 	int rc = 0;
 
Index: s390-tools-sles11/scripts/zfcpdbf
===================================================================
--- s390-tools-sles11.orig/scripts/zfcpdbf
+++ s390-tools-sles11/scripts/zfcpdbf
@@ -1,19 +1,20 @@
 #!/usr/bin/perl
 #==============================================================================
-# Copyright IBM Corp. 2005, 2006.
+# Copyright IBM Corp. 2005, 2009.
 #
 # zfcpdbf
 #
 # Script to analyse trace data of ZFCP module logged in DBF.
 #
 # Author(s): Maxim Shchetynin <maxim@de.ibm.com>
+#  	     Teresa Gamez Zerban <gamezt@de.ibm.com>
 #
 # This file is part of s390-tools
 #
 # s390-tools is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
+# (at your option) any later version.   
 #
 # s390-tools is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
